diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.34/src/wifi/model/he/rr-multi-user-scheduler.cc ns-3.35/src/wifi/model/he/rr-multi-user-scheduler.cc
--- ns-3.34/src/wifi/model/he/rr-multi-user-scheduler.cc	2021-07-14 10:31:07.000000000 -0700
+++ ns-3.35/src/wifi/model/he/rr-multi-user-scheduler.cc	2021-10-01 13:26:48.000000000 -0700
@@ -137,6 +137,13 @@
 {
   NS_LOG_FUNCTION (this);
 
+  Ptr<const WifiMacQueueItem> mpdu = m_edca->PeekNextMpdu ();
+
+  if (mpdu != 0 && !GetWifiRemoteStationManager ()->GetHeSupported (mpdu->GetHeader ().GetAddr1 ()))
+    {
+      return SU_TX;
+    }
+
   if (m_enableUlOfdma && m_enableBsrp && GetLastTxFormat () == DL_MU_TX)
     {
       return TrySendingBsrpTf ();
@@ -721,10 +728,9 @@
       NS_ASSERT (receiver == candidate.first->address);
 
       NS_ASSERT (mpdu->IsQueued ());
-      WifiMacQueueItem::QueueIteratorPair queueIt = mpdu->GetQueueIteratorPairs ().front ();
-      NS_ASSERT (queueIt.queue != nullptr);
-      Ptr<WifiMacQueueItem> item = *queueIt.it;
-      queueIt.it++;
+      WifiMacQueueItem::ConstIterator queueIt = mpdu->GetQueueIterator ();
+      Ptr<WifiMacQueueItem> item = *queueIt;
+      queueIt++;
 
       if (!mpdu->GetHeader ().IsRetry ())
         {
@@ -735,7 +741,7 @@
           if (item == nullptr)
             {
               // A-MSDU aggregation failed or disabled
-              item = *mpdu->GetQueueIteratorPairs ().front ().it;
+              item = *mpdu->GetQueueIterator ();
             }
           m_apMac->GetQosTxop (QosUtilsMapTidToAc (tid))->AssignSequenceNumber (item);
         }
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.34/src/wifi/model/ht/ht-frame-exchange-manager.cc ns-3.35/src/wifi/model/ht/ht-frame-exchange-manager.cc
--- ns-3.34/src/wifi/model/ht/ht-frame-exchange-manager.cc	2021-07-14 10:31:07.000000000 -0700
+++ ns-3.35/src/wifi/model/ht/ht-frame-exchange-manager.cc	2021-10-01 13:26:48.000000000 -0700
@@ -27,6 +27,8 @@
 #include "ns3/wifi-utils.h"
 #include "ns3/snr-tag.h"
 #include "ns3/ctrl-headers.h"
+#include <array>
+#include <optional>
 
 #undef NS_LOG_APPEND_CONTEXT
 #define NS_LOG_APPEND_CONTEXT std::clog << "[mac=" << m_self << "] "
@@ -182,6 +184,8 @@
   txParams.m_protection = std::unique_ptr<WifiProtection> (new WifiNoProtection);
   txParams.m_acknowledgment = GetAckManager ()->TryAddMpdu (mpdu, txParams);
 
+  // Push the MPDU to the front of the queue and transmit it
+  m_mac->GetQosTxop (tid)->GetWifiMacQueue ()->PushFront (mpdu);
   SendMpduWithProtection (mpdu, txParams);
 }
 
@@ -443,7 +447,7 @@
   Ptr<QosTxop> edca = m_mac->GetQosTxop (peekedItem->GetHeader ().GetQosTid ());
   WifiTxParameters txParams;
   txParams.m_txVector = m_mac->GetWifiRemoteStationManager ()->GetDataTxVector (peekedItem->GetHeader ());
-  WifiMacQueueItem::QueueIteratorPair queueIt;
+  WifiMacQueueItem::ConstIterator queueIt;
   Ptr<WifiMacQueueItem> mpdu = edca->GetNextMpdu (peekedItem, txParams, availableTime, initialFrame, queueIt);
 
   if (mpdu == nullptr)
@@ -801,6 +805,15 @@
   if (m_txParams.m_acknowledgment->method == WifiAcknowledgment::NONE)
     {
       Simulator::Schedule (txDuration, &HtFrameExchangeManager::TransmissionSucceeded, this);
+
+      std::set<uint8_t> tids = m_psdu->GetTids ();
+      NS_ASSERT_MSG (tids.size () <= 1, "Multi-TID A-MPDUs are not supported");
+
+      if (tids.size () == 0 || m_psdu->GetAckPolicyForTid (*tids.begin ()) == WifiMacHeader::NO_ACK)
+        {
+          // No acknowledgment, hence dequeue the PSDU if it is stored in a queue
+          DequeuePsdu (m_psdu);
+        }
     }
   else if (m_txParams.m_acknowledgment->method == WifiAcknowledgment::BLOCK_ACK)
     {
@@ -862,17 +875,32 @@
 {
   NS_LOG_FUNCTION (this << psdu);
 
+  // use an array to avoid computing the queue size for every MPDU in the PSDU
+  std::array<std::optional<uint8_t>, 8> queueSizeForTid;
+
   for (const auto& mpdu : *PeekPointer (psdu))
     {
-      if (mpdu->GetHeader ().IsQosData ())
+      WifiMacHeader& hdr = mpdu->GetHeader ();
+
+      if (hdr.IsQosData ())
         {
-          Ptr<QosTxop> edca = m_mac->GetQosTxop (mpdu->GetHeader ().GetQosTid ());
+          uint8_t tid = hdr.GetQosTid ();
+          Ptr<QosTxop> edca = m_mac->GetQosTxop (tid);
 
-          if (mpdu->GetHeader ().IsQosEosp ())
+          if (m_mac->GetTypeOfStation () == STA
+              && (m_setQosQueueSize || hdr.IsQosEosp ()))
             {
-              edca->SetQosQueueSize (mpdu);
+              // set the Queue Size subfield of the QoS Control field
+              if (!queueSizeForTid[tid].has_value ())
+                {
+                  queueSizeForTid[tid] = edca->GetQosQueueSize (tid, hdr.GetAddr1 ());
+                }
+
+              hdr.SetQosEosp ();
+              hdr.SetQosQueueSize (queueSizeForTid[tid].value ());
             }
-          if (mpdu->GetHeader ().HasData ())
+
+          if (hdr.HasData ())
             {
               edca->CompleteMpduTx (mpdu);
             }
@@ -881,33 +909,13 @@
 }
 
 void
-HtFrameExchangeManager::DequeueMpdu (Ptr<WifiMacQueueItem> mpdu)
-{
-  DequeuePsdu (Create<const WifiPsdu> (mpdu, true));
-}
-
-void
 HtFrameExchangeManager::DequeuePsdu (Ptr<const WifiPsdu> psdu)
 {
   NS_LOG_DEBUG (this << psdu);
 
   for (const auto& mpdu : *PeekPointer (psdu))
     {
-      if (mpdu->GetQueueIteratorPairs ().size () > 1)
-        {
-          // this MPDU contains an A-MSDU
-          for (const auto& queueIt : mpdu->GetQueueIteratorPairs ())
-            {
-              NS_ASSERT (*queueIt.it != mpdu);
-              queueIt.queue->Dequeue (queueIt.it);
-            }
-        }
-      else if (mpdu->IsQueued ())
-        {
-          WifiMacQueueItem::QueueIteratorPair queueIt = mpdu->GetQueueIteratorPairs ().front ();
-          NS_ASSERT (*queueIt.it == mpdu);
-          queueIt.queue->Dequeue (queueIt.it);
-        }
+      DequeueMpdu (mpdu);
     }
 }
 
@@ -924,9 +932,6 @@
       txVector.SetAggregation (true);
     }
 
-  // The PSDU is about to be transmitted, we can now dequeue the MPDUs
-  DequeuePsdu (psdu);
-
   m_phy->Send (psdu, txVector);
 }
 
@@ -1197,21 +1202,9 @@
           if (GetBaManager (tid)->ExistsAgreementInState (recipient, tid,
                                                           OriginatorBlockAckAgreement::ESTABLISHED))
             {
-              // If there is any (expired) outstanding MPDU, request the BA manager to discard
-              // it, which involves the scheduling of a BAR to advance the recipient's window
-              if (GetBaManager (tid)->GetNBufferedPackets (recipient, tid) > 0)
-                {
-                  GetBaManager (tid)->DiscardOutstandingMpdus (recipient, tid);
-                }
-              // otherwise, it means that we have not received a Block Ack in response to a
-              // BlockAckRequest sent while no frame was outstanding, whose purpose was therefore
-              // to advance the recipient's window. Schedule a BlockAckRequest with
-              // skipIfNoDataQueued set to true, so that the BlockAckRequest is only sent
-              // if there are data frames queued for this recipient.
-              else
-                {
-                  edca->ScheduleBar (edca->PrepareBlockAckRequest (recipient, tid), true);
-                }
+              // schedule a BlockAckRequest with skipIfNoDataQueued set to true, so that the
+              // BlockAckRequest is only sent if there are data frames queued for this recipient.
+              edca->ScheduleBar (edca->PrepareBlockAckRequest (recipient, tid), true);
             }
           resetCw = true;
         }
@@ -1225,9 +1218,9 @@
           m_mac->GetWifiRemoteStationManager ()->ReportFinalDataFailed (*psdu->begin ());
           for (const auto& mpdu : *PeekPointer (psdu))
             {
-              FrameExchangeManager::NotifyPacketDiscarded (mpdu);
+              NotifyPacketDiscarded (mpdu);
+              DequeueMpdu (mpdu);
             }
-          GetBaManager (tid)->DiscardOutstandingMpdus (recipient, tid);
           resetCw = true;
         }
       else
@@ -1343,8 +1336,9 @@
           CtrlBAckResponseHeader blockAck;
           mpdu->GetPacket ()->PeekHeader (blockAck);
           uint8_t tid = blockAck.GetTidInfo ();
-          GetBaManager (tid)->NotifyGotBlockAck (blockAck, hdr.GetAddr2 (), {tid}, rxSnr,
-                                                 tag.Get (), m_txParams.m_txVector);
+          std::pair<uint16_t,uint16_t> ret = GetBaManager (tid)->NotifyGotBlockAck (blockAck, hdr.GetAddr2 (), {tid});
+          m_mac->GetWifiRemoteStationManager ()->ReportAmpduTxStatus (hdr.GetAddr2 (), ret.first, ret.second,
+                                                                      rxSnr, tag.Get (),  m_txParams.m_txVector);
 
           // cancel the timer
           m_txTimer.Cancel ();
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.34/src/wifi/model/ht/ht-frame-exchange-manager.h ns-3.35/src/wifi/model/ht/ht-frame-exchange-manager.h
--- ns-3.34/src/wifi/model/ht/ht-frame-exchange-manager.h	2021-07-14 10:31:07.000000000 -0700
+++ ns-3.35/src/wifi/model/ht/ht-frame-exchange-manager.h	2021-10-01 13:26:48.000000000 -0700
@@ -148,9 +148,9 @@
    * This function is typically invoked only by ns3::RegularWifiMac
    * when the STA (which may be non-AP in ESS, or in an IBSS) has
    * received an ADDBA Request frame and is transmitting an ADDBA
-   * Response frame. At this point MacLow must allocate buffers to
-   * collect all correctly received packets belonging to the category
-   * for which block ack was negotiated.
+   * Response frame. At this point the frame exchange manager must
+   * allocate buffers to collect all correctly received packets belonging
+   * to the category for which block ack was negotiated.
    */
   void CreateBlockAckAgreement (const MgtAddBaResponseHeader *respHdr,
                                 Mac48Address originator, uint16_t startingSeq);
@@ -212,7 +212,6 @@
   void ForwardMpduDown (Ptr<WifiMacQueueItem> mpdu, WifiTxVector& txVector) override;
   void CtsTimeout (Ptr<WifiMacQueueItem> rts, const WifiTxVector& txVector) override;
   void TransmissionSucceeded (void) override;
-  void DequeueMpdu (Ptr<WifiMacQueueItem> mpdu) override;
 
   /**
    * Get a PSDU containing the given MPDU
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.34/src/wifi/model/ht/ht-phy.cc ns-3.35/src/wifi/model/ht/ht-phy.cc
--- ns-3.34/src/wifi/model/ht/ht-phy.cc	2021-07-14 10:31:07.000000000 -0700
+++ ns-3.35/src/wifi/model/ht/ht-phy.cc	2021-10-01 13:26:48.000000000 -0700
@@ -382,7 +382,7 @@
 HtPhy::EndReceiveHtSig (Ptr<Event> event)
 {
   NS_LOG_FUNCTION (this << *event);
-  NS_ASSERT (IsHt (event->GetTxVector ().GetPreambleType ()));
+  NS_ASSERT (event->GetTxVector ().GetPreambleType () == WIFI_PREAMBLE_HT_MF);
   SnrPer snrPer = GetPhyHeaderSnrPer (WIFI_PPDU_FIELD_HT_SIG, event);
   NS_LOG_DEBUG ("HT-SIG: SNR(dB)=" << RatioToDb (snrPer.snr) << ", PER=" << snrPer.per);
   PhyFieldRxStatus status (GetRandomValue () > snrPer.per);
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.34/src/wifi/model/interference-helper.cc ns-3.35/src/wifi/model/interference-helper.cc
--- ns-3.34/src/wifi/model/interference-helper.cc	2021-07-14 10:31:07.000000000 -0700
+++ ns-3.35/src/wifi/model/interference-helper.cc	2021-10-01 13:26:48.000000000 -0700
@@ -38,12 +38,12 @@
  *       PHY event class
  ****************************************************************/
 
-Event::Event (Ptr<const WifiPpdu> ppdu, const WifiTxVector& txVector, Time duration, RxPowerWattPerChannelBand rxPower)
+Event::Event (Ptr<const WifiPpdu> ppdu, const WifiTxVector& txVector, Time duration, RxPowerWattPerChannelBand&& rxPower)
   : m_ppdu (ppdu),
     m_txVector (txVector),
     m_startTime (Simulator::Now ()),
     m_endTime (m_startTime + duration),
-    m_rxPowerW (rxPower)
+    m_rxPowerW (std::move (rxPower))
 {
 }
 
@@ -97,7 +97,7 @@
   return it->second;
 }
 
-RxPowerWattPerChannelBand
+const RxPowerWattPerChannelBand&
 Event::GetRxPowerWPerBand (void) const
 {
   return m_rxPowerW;
@@ -110,7 +110,7 @@
 }
 
 void
-Event::UpdateRxPowerW (RxPowerWattPerChannelBand rxPower)
+Event::UpdateRxPowerW (const RxPowerWattPerChannelBand& rxPower)
 {
   NS_ASSERT (rxPower.size () == m_rxPowerW.size ());
   //Update power band per band
@@ -187,15 +187,15 @@
 }
 
 Ptr<Event>
-InterferenceHelper::Add (Ptr<const WifiPpdu> ppdu, const WifiTxVector& txVector, Time duration, RxPowerWattPerChannelBand rxPowerW, bool isStartOfdmaRxing)
+InterferenceHelper::Add (Ptr<const WifiPpdu> ppdu, const WifiTxVector& txVector, Time duration, RxPowerWattPerChannelBand& rxPowerW, bool isStartOfdmaRxing)
 {
-  Ptr<Event> event = Create<Event> (ppdu, txVector, duration, rxPowerW);
+  Ptr<Event> event = Create<Event> (ppdu, txVector, duration, std::move (rxPowerW));
   AppendEvent (event, isStartOfdmaRxing);
   return event;
 }
 
 void
-InterferenceHelper::AddForeignSignal (Time duration, RxPowerWattPerChannelBand rxPowerW)
+InterferenceHelper::AddForeignSignal (Time duration, RxPowerWattPerChannelBand& rxPowerW)
 {
   // Parameters other than duration and rxPowerW are unused for this type
   // of signal, so we provide dummy versions
@@ -225,9 +225,10 @@
   NS_LOG_FUNCTION (this << band.first << band.second);
   NS_ASSERT (m_niChangesPerBand.find (band) == m_niChangesPerBand.end ());
   NiChanges niChanges;
-  m_niChangesPerBand.insert ({band, niChanges});
+  auto result = m_niChangesPerBand.insert ({band, niChanges});
+  NS_ASSERT (result.second);
   // Always have a zero power noise event in the list
-  AddNiChangeEvent (Time (0), NiChange (0.0, 0), band);
+  AddNiChangeEvent (Time (0), NiChange (0.0, 0), result.first);
   m_firstPowerPerBand.insert ({band, 0.0});
 }
 
@@ -259,11 +260,11 @@
 InterferenceHelper::GetEnergyDuration (double energyW, WifiSpectrumBand band)
 {
   Time now = Simulator::Now ();
-  auto i = GetPreviousPosition (now, band);
+  auto niIt = m_niChangesPerBand.find (band);
+  NS_ASSERT (niIt != m_niChangesPerBand.end ());
+  auto i = GetPreviousPosition (now, niIt);
   Time end = i->first;
-  auto ni_it = m_niChangesPerBand.find (band);
-  NS_ASSERT (ni_it != m_niChangesPerBand.end ());
-  for (; i != ni_it->second.end (); ++i)
+  for (; i != niIt->second.end (); ++i)
     {
       double noiseInterferenceW = i->second.GetPower ();
       end = i->first;
@@ -279,21 +280,21 @@
 InterferenceHelper::AppendEvent (Ptr<Event> event, bool isStartOfdmaRxing)
 {
   NS_LOG_FUNCTION (this << event << isStartOfdmaRxing);
-  RxPowerWattPerChannelBand rxPowerWattPerChannelBand = event->GetRxPowerWPerBand ();
-  for (auto const& it : rxPowerWattPerChannelBand)
+  for (auto const& it : event->GetRxPowerWPerBand ())
     {
       WifiSpectrumBand band = it.first;
-      auto ni_it = m_niChangesPerBand.find (band);
-      NS_ASSERT (ni_it != m_niChangesPerBand.end ());
+      auto niIt = m_niChangesPerBand.find (band);
+      NS_ASSERT (niIt != m_niChangesPerBand.end ());
       double previousPowerStart = 0;
       double previousPowerEnd = 0;
-      previousPowerStart = GetPreviousPosition (event->GetStartTime (), band)->second.GetPower ();
-      previousPowerEnd = GetPreviousPosition (event->GetEndTime (), band)->second.GetPower ();
+      auto previousPowerPosition = GetPreviousPosition (event->GetStartTime (), niIt);
+      previousPowerStart = previousPowerPosition->second.GetPower ();
+      previousPowerEnd = GetPreviousPosition (event->GetEndTime (), niIt)->second.GetPower ();
       if (!m_rxing)
         {
           m_firstPowerPerBand.find (band)->second = previousPowerStart;
           // Always leave the first zero power noise event in the list
-          ni_it->second.erase (++(ni_it->second.begin ()), GetNextPosition (event->GetStartTime (), band));
+          niIt->second.erase (++(niIt->second.begin ()), ++previousPowerPosition);
         }
       else if (isStartOfdmaRxing)
         {
@@ -302,8 +303,8 @@
           //UL MU transmission and the start of UL-OFDMA payload.
           m_firstPowerPerBand.find (band)->second = previousPowerStart;
         }
-      auto first = AddNiChangeEvent (event->GetStartTime (), NiChange (previousPowerStart, event), band);
-      auto last = AddNiChangeEvent (event->GetEndTime (), NiChange (previousPowerEnd, event), band);
+      auto first = AddNiChangeEvent (event->GetStartTime (), NiChange (previousPowerStart, event), niIt);
+      auto last = AddNiChangeEvent (event->GetEndTime (), NiChange (previousPowerEnd, event), niIt);
       for (auto i = first; i != last; ++i)
         {
           i->second.AddPower (it.second);
@@ -312,17 +313,17 @@
 }
 
 void
-InterferenceHelper::UpdateEvent (Ptr<Event> event, RxPowerWattPerChannelBand rxPower)
+InterferenceHelper::UpdateEvent (Ptr<Event> event, const RxPowerWattPerChannelBand& rxPower)
 {
   NS_LOG_FUNCTION (this << event);
   //This is called for UL MU events, in order to scale power as long as UL MU PPDUs arrive
   for (auto const& it : rxPower)
     {
       WifiSpectrumBand band = it.first;
-      auto ni_it = m_niChangesPerBand.find (band);
-      NS_ASSERT (ni_it != m_niChangesPerBand.end ());
-      auto first = GetPreviousPosition (event->GetStartTime (), band);
-      auto last = GetPreviousPosition (event->GetEndTime (), band);
+      auto niIt = m_niChangesPerBand.find (band);
+      NS_ASSERT (niIt != m_niChangesPerBand.end ());
+      auto first = GetPreviousPosition (event->GetStartTime (), niIt);
+      auto last = GetPreviousPosition (event->GetEndTime (), niIt);
       for (auto i = first; i != last; ++i)
         {
           i->second.AddPower (it.second);
@@ -364,19 +365,19 @@
   auto firstPower_it = m_firstPowerPerBand.find (band);
   NS_ASSERT (firstPower_it != m_firstPowerPerBand.end ());
   double noiseInterferenceW = firstPower_it->second;
-  auto ni_it = m_niChangesPerBand.find (band);
-  NS_ASSERT (ni_it != m_niChangesPerBand.end ());
-  auto it = ni_it->second.find (event->GetStartTime ());
-  for (; it != ni_it->second.end () && it->first < Simulator::Now (); ++it)
+  auto niIt = m_niChangesPerBand.find (band);
+  NS_ASSERT (niIt != m_niChangesPerBand.end ());
+  auto it = niIt->second.find (event->GetStartTime ());
+  for (; it != niIt->second.end () && it->first < Simulator::Now (); ++it)
     {
       noiseInterferenceW = it->second.GetPower () - event->GetRxPowerW (band);
     }
-  it = ni_it->second.find (event->GetStartTime ());
-  NS_ASSERT (it != ni_it->second.end ());
-  for (; it != ni_it->second.end () && it->second.GetEvent () != event; ++it);
+  it = niIt->second.find (event->GetStartTime ());
+  NS_ASSERT (it != niIt->second.end ());
+  for (; it != niIt->second.end () && it->second.GetEvent () != event; ++it);
   NiChanges ni;
   ni.emplace (event->GetStartTime (), NiChange (0, event));
-  while (++it != ni_it->second.end () && it->second.GetEvent () != event)
+  while (++it != niIt->second.end () && it->second.GetEvent () != event)
     {
       ni.insert (*it);
     }
@@ -421,8 +422,8 @@
 {
   NS_LOG_FUNCTION (this << channelWidth << band.first << band.second << staId << window.first << window.second);
   double psr = 1.0; /* Packet Success Rate */
-  auto ni_it = nis->find (band)->second;
-  auto j = ni_it.begin ();
+  auto niIt = nis->find (band)->second;
+  auto j = niIt.begin ();
   Time previous = j->first;
   WifiMode payloadMode = event->GetTxVector ().GetMode (staId);
   Time phyPayloadStart = j->first;
@@ -434,7 +435,7 @@
   Time windowEnd = phyPayloadStart + window.second;
   double noiseInterferenceW = m_firstPowerPerBand.find (band)->second;
   double powerW = event->GetRxPowerW (band);
-  while (++j != ni_it.end ())
+  while (++j != niIt.end ())
     {
       Time current = j->first;
       NS_LOG_DEBUG ("previous= " << previous << ", current=" << current);
@@ -471,8 +472,8 @@
 {
   NS_LOG_FUNCTION (this << band.first << band.second);
   double psr = 1.0; /* Packet Success Rate */
-  auto ni_it = nis->find (band)->second;
-  auto j = ni_it.begin ();
+  auto niIt = nis->find (band)->second;
+  auto j = niIt.begin ();
 
   NS_ASSERT (!phyHeaderSections.empty ());
   Time stopLastSection = Seconds (0);
@@ -484,7 +485,7 @@
   Time previous = j->first;
   double noiseInterferenceW = m_firstPowerPerBand.find (band)->second;
   double powerW = event->GetRxPowerW (band);
-  while (++j != ni_it.end ())
+  while (++j != niIt.end ())
     {
       Time current = j->first;
       NS_LOG_DEBUG ("previous= " << previous << ", current=" << current);
@@ -523,11 +524,11 @@
                                            WifiPpduField header) const
 {
   NS_LOG_FUNCTION (this << band.first << band.second << header);
-  auto ni_it = nis->find (band)->second;
+  auto niIt = nis->find (band)->second;
   auto phyEntity = WifiPhy::GetStaticPhyEntity (event->GetTxVector ().GetModulationClass ());
 
   PhyEntity::PhyHeaderSections sections;
-  for (const auto & section : phyEntity->GetPhyHeaderSections (event->GetTxVector (), ni_it.begin ()->first))
+  for (const auto & section : phyEntity->GetPhyHeaderSections (event->GetTxVector (), niIt.begin ()->first))
     {
       if (section.first == header)
         {
@@ -598,28 +599,26 @@
 void
 InterferenceHelper::EraseEvents (void)
 {
-  for (auto it : m_niChangesPerBand)
+  for (auto niIt = m_niChangesPerBand.begin(); niIt != m_niChangesPerBand.end(); ++niIt)
     {
-      it.second.clear ();
+      niIt->second.clear ();
       // Always have a zero power noise event in the list
-      AddNiChangeEvent (Time (0), NiChange (0.0, 0), it.first);
-      m_firstPowerPerBand.at (it.first) = 0.0;
+      AddNiChangeEvent (Time (0), NiChange (0.0, 0), niIt);
+      m_firstPowerPerBand.at (niIt->first) = 0.0;
     }
   m_rxing = false;
 }
 
 InterferenceHelper::NiChanges::iterator
-InterferenceHelper::GetNextPosition (Time moment, WifiSpectrumBand band)
+InterferenceHelper::GetNextPosition (Time moment, NiChangesPerBand::iterator niIt)
 {
-  auto it = m_niChangesPerBand.find (band);
-  NS_ASSERT (it != m_niChangesPerBand.end ());
-  return it->second.upper_bound (moment);
+  return niIt->second.upper_bound (moment);
 }
 
 InterferenceHelper::NiChanges::iterator
-InterferenceHelper::GetPreviousPosition (Time moment, WifiSpectrumBand band)
+InterferenceHelper::GetPreviousPosition (Time moment, NiChangesPerBand::iterator niIt)
 {
-  auto it = GetNextPosition (moment, band);
+  auto it = GetNextPosition (moment, niIt);
   // This is safe since there is always an NiChange at time 0,
   // before moment.
   --it;
@@ -627,11 +626,9 @@
 }
 
 InterferenceHelper::NiChanges::iterator
-InterferenceHelper::AddNiChangeEvent (Time moment, NiChange change, WifiSpectrumBand band)
+InterferenceHelper::AddNiChangeEvent (Time moment, NiChange change, NiChangesPerBand::iterator niIt)
 {
-  auto it = m_niChangesPerBand.find (band);
-  NS_ASSERT (it != m_niChangesPerBand.end ());
-  return it->second.insert (GetNextPosition (moment, band), std::make_pair (moment, change));
+  return niIt->second.insert (GetNextPosition (moment, niIt), std::make_pair (moment, change));
 }
 
 void
@@ -647,12 +644,12 @@
   NS_LOG_FUNCTION (this << endTime);
   m_rxing = false;
   //Update m_firstPowerPerBand for frame capture
-  for (auto ni : m_niChangesPerBand)
+  for (auto niIt = m_niChangesPerBand.begin(); niIt != m_niChangesPerBand.end(); ++niIt)
     {
-      NS_ASSERT (ni.second.size () > 1);
-      auto it = GetPreviousPosition (endTime, ni.first);
+      NS_ASSERT (niIt->second.size () > 1);
+      auto it = GetPreviousPosition (endTime, niIt);
       it--;
-      m_firstPowerPerBand.find (ni.first)->second = it->second.GetPower ();
+      m_firstPowerPerBand.find (niIt->first)->second = it->second.GetPower ();
     }
 }
 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.34/src/wifi/model/interference-helper.h ns-3.35/src/wifi/model/interference-helper.h
--- ns-3.34/src/wifi/model/interference-helper.h	2021-07-14 10:31:07.000000000 -0700
+++ ns-3.35/src/wifi/model/interference-helper.h	2021-10-01 13:26:48.000000000 -0700
@@ -38,14 +38,15 @@
 {
 public:
   /**
-   * Create an Event with the given parameters.
+   * Create an Event with the given parameters. Note that <i>rxPower</i> will
+   * be moved into this object.
    *
    * \param ppdu the PPDU
    * \param txVector the TXVECTOR
    * \param duration duration of the PPDU
    * \param rxPower the received power per band (W)
    */
-  Event (Ptr<const WifiPpdu> ppdu, const WifiTxVector& txVector, Time duration, RxPowerWattPerChannelBand rxPower);
+  Event (Ptr<const WifiPpdu> ppdu, const WifiTxVector& txVector, Time duration,  RxPowerWattPerChannelBand&& rxPower);
   ~Event ();
 
   /**
@@ -90,7 +91,7 @@
    *
    * \return the received power (W) for all bands.
    */
-  RxPowerWattPerChannelBand GetRxPowerWPerBand (void) const;
+  const RxPowerWattPerChannelBand& GetRxPowerWPerBand (void) const;
   /**
    * Return the TXVECTOR of the PPDU.
    *
@@ -103,7 +104,7 @@
    *
    * \param rxPower the received power (W) for all bands.
    */
-  void UpdateRxPowerW (RxPowerWattPerChannelBand rxPower);
+  void UpdateRxPowerW (const RxPowerWattPerChannelBand& rxPower);
 
 
 private:
@@ -194,14 +195,14 @@
    *
    * \return Event
    */
-  Ptr<Event> Add (Ptr<const WifiPpdu> ppdu, const WifiTxVector& txVector, Time duration, RxPowerWattPerChannelBand rxPower, bool isStartOfdmaRxing = false);
+  Ptr<Event> Add (Ptr<const WifiPpdu> ppdu, const WifiTxVector& txVector, Time duration, RxPowerWattPerChannelBand& rxPower, bool isStartOfdmaRxing = false);
 
   /**
    * Add a non-Wifi signal to interference helper.
    * \param duration the duration of the signal
    * \param rxPower received power per band (W)
    */
-  void AddForeignSignal (Time duration, RxPowerWattPerChannelBand rxPower);
+  void AddForeignSignal (Time duration, RxPowerWattPerChannelBand& rxPower);
   /**
    * Calculate the SNIR at the start of the payload and accumulate
    * all SNIR changes in the SNIR vector for each MPDU of an A-MPDU.
@@ -265,7 +266,7 @@
    * \param event the event to be updated
    * \param rxPower the received power (W) per band to be added to the current event
    */
-  void UpdateEvent (Ptr<Event> event, RxPowerWattPerChannelBand rxPower);
+  void UpdateEvent (Ptr<Event> event, const RxPowerWattPerChannelBand& rxPower);
 
 
 protected:
@@ -431,18 +432,18 @@
    * Returns an iterator to the first NiChange that is later than moment
    *
    * \param moment time to check from
-   * \param band identify the band to check
+   * \param niIt iterator of the band to check
    * \returns an iterator to the list of NiChanges
    */
-  NiChanges::iterator GetNextPosition (Time moment, WifiSpectrumBand band);
+  NiChanges::iterator GetNextPosition (Time moment, NiChangesPerBand::iterator niIt);
   /**
    * Returns an iterator to the last NiChange that is before than moment
    *
    * \param moment time to check from
-   * \param band identify the band to check
+   * \param niIt iterator of the band to check
    * \returns an iterator to the list of NiChanges
    */
-  NiChanges::iterator GetPreviousPosition (Time moment, WifiSpectrumBand band);
+  NiChanges::iterator GetPreviousPosition (Time moment, NiChangesPerBand::iterator niIt);
 
   /**
    * Add NiChange to the list at the appropriate position and
@@ -450,10 +451,10 @@
    *
    * \param moment time to check from
    * \param change the NiChange to add
-   * \param band identify the band to check
+   * \param niIt iterator of the band to check
    * \returns the iterator of the new event
    */
-  NiChanges::iterator AddNiChangeEvent (Time moment, NiChange change, WifiSpectrumBand band);
+  NiChanges::iterator AddNiChangeEvent (Time moment, NiChange change, NiChangesPerBand::iterator niIt);
 };
 
 } //namespace ns3
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.34/src/wifi/model/mgt-headers.cc ns-3.35/src/wifi/model/mgt-headers.cc
--- ns-3.34/src/wifi/model/mgt-headers.cc	2021-07-14 10:31:07.000000000 -0700
+++ ns-3.35/src/wifi/model/mgt-headers.cc	2021-10-01 13:26:48.000000000 -0700
@@ -360,12 +360,24 @@
   m_edcaParameterSet = edcaParameters;
 }
 
+void
+MgtProbeResponseHeader::SetMuEdcaParameterSet (MuEdcaParameterSet muEdcaParameters)
+{
+  m_muEdcaParameterSet = muEdcaParameters;
+}
+
 EdcaParameterSet
 MgtProbeResponseHeader::GetEdcaParameterSet (void) const
 {
   return m_edcaParameterSet;
 }
 
+MuEdcaParameterSet
+MgtProbeResponseHeader::GetMuEdcaParameterSet (void) const
+{
+  return m_muEdcaParameterSet;
+}
+
 TypeId
 MgtProbeResponseHeader::GetTypeId (void)
 {
@@ -403,6 +415,7 @@
   size += m_vhtOperation.GetSerializedSize ();
   size += m_heCapability.GetSerializedSize ();
   size += m_heOperation.GetSerializedSize ();
+  size += m_muEdcaParameterSet.GetSerializedSize ();
   return size;
 }
 
@@ -450,6 +463,7 @@
   i = m_vhtOperation.Serialize (i);
   i = m_heCapability.Serialize (i);
   i = m_heOperation.Serialize (i);
+  i = m_muEdcaParameterSet.Serialize (i);
 }
 
 uint32_t
@@ -473,6 +487,7 @@
   i = m_vhtOperation.DeserializeIfPresent (i);
   i = m_heCapability.DeserializeIfPresent (i);
   i = m_heOperation.DeserializeIfPresent (i);
+  i = m_muEdcaParameterSet.DeserializeIfPresent (i);
   return i.GetDistanceFrom (start);
 }
 
@@ -1045,12 +1060,24 @@
   m_edcaParameterSet = edcaparameters;
 }
 
+void
+MgtAssocResponseHeader::SetMuEdcaParameterSet (MuEdcaParameterSet muEdcaParameters)
+{
+  m_muEdcaParameterSet = muEdcaParameters;
+}
+
 EdcaParameterSet
 MgtAssocResponseHeader::GetEdcaParameterSet (void) const
 {
   return m_edcaParameterSet;
 }
 
+MuEdcaParameterSet
+MgtAssocResponseHeader::GetMuEdcaParameterSet (void) const
+{
+  return m_muEdcaParameterSet;
+}
+
 TypeId
 MgtAssocResponseHeader::GetTypeId (void)
 {
@@ -1086,6 +1113,7 @@
   size += m_vhtOperation.GetSerializedSize ();
   size += m_heCapability.GetSerializedSize ();
   size += m_heOperation.GetSerializedSize ();
+  size += m_muEdcaParameterSet.GetSerializedSize ();
   return size;
 }
 
@@ -1123,6 +1151,7 @@
   i = m_vhtOperation.Serialize (i);
   i = m_heCapability.Serialize (i);
   i = m_heOperation.Serialize (i);
+  i = m_muEdcaParameterSet.Serialize (i);
 }
 
 uint32_t
@@ -1143,6 +1172,7 @@
   i = m_vhtOperation.DeserializeIfPresent (i);
   i = m_heCapability.DeserializeIfPresent (i);
   i = m_heOperation.DeserializeIfPresent (i);
+  i = m_muEdcaParameterSet.DeserializeIfPresent (i);
   return i.GetDistanceFrom (start);
 }
 
